import sqlite3


def get_geolocation_by_city_name(city_name):
    conn = sqlite3.connect('cities.db')
    cur = conn.cursor()
    cur.execute('select Latitude, Longitude from cities where City = ? COLLATE NOCASE', (city_name,))
    city = cur.fetchone()
    if city is None: raise Exception("Invalid City Name")
    return (_nomalize_geolocation(city[0]), _nomalize_geolocation(city[1]))   # (latitude, longitude)


def get_all_cities():
    conn = sqlite3.connect('cities.db')
    cur = conn.cursor()
    cur.execute('select City from cities ORDER BY City')
    result=[]
    for city_name in cur.fetchall(): result.append(city_name[0])
    return result


def _nomalize_geolocation(geolocation):
    # Input format : 8°07′S
    degree_sym = geolocation.find(chr(65533))
    question_sym = geolocation.find('?')
    whole_part = int(geolocation[:degree_sym])
    fraction_part=int(geolocation[degree_sym+1:question_sym])
    direction=geolocation[-1]
    return (-1 if direction in ['S', 'W'] else 1) *  whole_part + (fraction_part/60)

